{{

}}                                                                                                                                                
CON
_clkmode = xtal1 + pll16x                                                      
_xinfreq = 5_000_000

SDA_pin = 29
SCL_pin = 28

BMP = $77

VAR
  word                array[11]

OBJ
  I2C : "I2C Spin driver v1.2"
  FDS : "FullDuplexSerial"

PUB Main | device_id, register, n
  I2C.start(SCL_pin,SDA_pin)
  FDS.start(31,30,0,115_200)
  waitcnt(clkfreq + cnt)                                                      
  FDS.tx($00)

  if not \I2C.command(BMP,$AA)                                                                                ' Test to see if the pressure sensor is on the bus
    FDS.str(string(" BMP058 not found at address $77.  Polling bus for other I2C devices.",$0D,$0D))
    device_id := 0
    repeat until device_id == $80                                                                            
      if \I2C.command(device_id,0)                                                                            '  This is just to make sure that everything else is working
        FDS.str(string("Device found at %"))                                                                  '  The EEPROM should show up as %1010000 if using P28 and P29 for I2C
        FDS.bin(device_id,7)                                                                                  '  The BMP058 should show up as %1110111
        FDS.tx($0D)                                                                                           
      device_id++
    repeat                                                                                                    ' Halt program

{I'm not even going to pretend to understand that datasheet, so this is just going to list all of the registers from AA through BF as 11 words}

  n~
  if \I2C.read_words(BMP,$AA,@array,11)                 ' Read 11 words from BMP58 starting at register $AA
    repeat register from $AA to $BE step 2
      FDS.hex(register,2)
      FDS.str(string(": "))
      FDS.hex(array[n],4)
      n += 2
      FDS.tx($0D)